#!/usr/bin/python
"""
Author: Anja Spang
will replace a specific characteri by another (or none at all)
"""


#Import modules
##########################################################################################

import sys
from Bio import SeqIO
import argparse



#ARGPARSE
##########################################################################################
parser = argparse.ArgumentParser(description='Replace a specific charater in a sequence by another')
parser.add_argument('-a','--input1', metavar='fasta', required = True, help='multifasta')
parser.add_argument('-f','--input2', metavar= str, required = True, help='character to be replaced')
parser.add_argument('-r','--input3', metavar= str, required = False, help='character, with which to replace previous character')
parser.add_argument('-o','--output', metavar='fasta', required = True, help= 'multifasta with replaced character')
args = parser.parse_args()

if args.input1 is None and not os.path.exists(args.input):
  print("multifasta file is file missing!")
  sys.exit(-1)

if args.input2 is None and not os.path.exists(args.input):
  print("character to be found is missing")
  sys.exit(-1)




#Global variables
##########################################################################################

infile = open(args.input1)
outfile= open("%s" % args.output,'w')
find_char= str(args.input2)
replace_char = str(args.input3)


#Function to replace character in sequence by another
##########################################################################################

def Replace_char_by_another(multifasta, findstring, replacestring):
	for seq_record in SeqIO.parse(multifasta,"fasta"):
		header = str(seq_record.description).strip()
		seq = str(seq_record.seq).strip()
		if replacestring == "None":
			seq_new = seq.replace(find_char, '').upper()
			outfile.write(">%s\n%s\n" % (header, seq_new))
		else:
			seq_new = seq.replace(find_char, replace_char).upper()
			outfile.write(">%s\n%s\n" % (header, seq_new))



#Call main
##########################################################################################

def main():
	Replace_char_by_another(infile, find_char, replace_char)


if __name__ == "__main__":
	main()




#Close files
##########################################################################################
outfile.close()
